const mariadb = require('./_db');



async function getUsers(){
    try {
        let conn = await mariadb.getConn();

        const rows = await conn.query("SELECT * FROM user");

        conn.release();

        return rows; 
    }
    catch(err){
        console.log("No se pudo acceder a la BD: "+err);
    }
}

module.exports.getUsers = getUsers;

async function userLogin(username, password){
    try {
        let conn = await mariadb.getConn();

        const rows = await conn.query("SELECT userID, discotecaID, userType, username FROM user WHERE username = ? AND password = ?", [username, password]);
        conn.release();

        if (rows){
        return rows;}
    }
    catch(err){
        console.log("No se pudo acceder a la BD: "+err);
    }
}

module.exports.userLogin = userLogin;

async function getDiscoteca(discotecaId){
   try{
    let conn = await mariadb.getConn();
    const rows = await conn.query("SELECT discotecaID, nombre, telefono, localizacion FROM discoteca WHERE discotecaID = ?", [discotecaId]);
    conn.release();

    if (rows){
        return rows;}
    
    }catch(err){
        console.log("No se pudo acceder a la BD: "+err);
    }

}

module.exports.getDiscoteca = getDiscoteca;

async function addEvento(evento){
    try{
        let conn = await mariadb.getConn();
        var rows = await conn.query ("SELECT * FROM evento WHERE id = ?", [evento.id]);
        conn.release();
        if (!rows){
            rows = await conn.query
            ("INSERT INTO evento (discotecaID, nombre, localizacion, fecha, hora, descripcion, precio1, precio2) VALUES (?, ?, ?, ?, ?, ?, ?, ?)",
            [evento.discotecaID, evento.nombre, evento.localizacion, evento.fecha, evento.hora, evento.descripcion, evento.precio1, evento.precio2]);
            conn.release();}
        
        else{
            rows = await conn.query
            ("UPDATE evento SET discotecaID = ?, nombre = ?, localizacion = ?, fecha = ?, hora = ?, descripcion = ?, precio1 = ?, precio2 = ? WHERE id = ?", 
            [evento.discotecaID, evento.nombre, evento.localizacion, evento.fecha, evento.hora, evento.descripcion, evento.precio1, evento.precio2, evento.id]);
        }

        if (rows){
            return rows;}
        
        }catch(err){
            console.log("No se pudo acceder a la BD: "+err);
        }
    
}

module.exports.addEvento = addEvento;

async function getEventos(){
    try{
    let conn = await mariadb.getConn();
    const rows = await conn.query("SELECT id, discotecaID, nombre, localizacion, fecha, hora, descripcion, precio1, precio2 FROM evento");
    conn.release();

    if(rows){
        return rows;}
    }catch(err){
        console.log("No se pudo acceder a la BD: "+err);
    }
}

module.exports.getEventos = getEventos;

async function getEventosDiscoteca(discotecaId){
    try{
        let conn = await mariadb.getConn();
        const rows = await conn.query("SELECT id, discotecaID, nombre, localizacion, fecha, hora, descripcion, precio1, precio2 FROM evento WHERE discotecaID = ?", [discotecaId.id]);
        conn.release();
    
        if (rows){
            return rows;}
        
        }catch(err){
            console.log("No se pudo acceder a la BD: "+err);
        }
}

module.exports.getEventosDiscoteca = getEventosDiscoteca;



async function addReserva(reserva){
    try{
        let conn = await mariadb.getConn();
        var rows = await conn.query("SELECT * FROM reserva WHERE UserID = ? AND eventoID = ?", [reserva.userID, reserva.eventoID]);
        if(!rows){ //primero inserta en la tabla codigo, y luego en la tabla reserva
            reserva.codigoUnicoID = await conn.query("INSERT INTO codigo (UserID, codigo, numReservas) VALUES (?, ?, ?)", 
            [reserva.userID, reserva.codigo, reserva.numReservas]);
            rows = await conn.query("INSERT INTO reserva (UserID, EventoID, codigoUnicoID, codigoDescuento, descuentoPorciento) VALUES (?, ?, ?, ?, ?)", 
            [reserva.userID, reserva.eventoID, reserva.codigoUnicoID, reserva.codigoDescuento, reserva.descuentoPorciento]);
            return rows;
        }
        else{
            console.log("Ya hay una reserva para este evento.");
        }
    }catch(err){
        console.log("No se pudo acceder a la BD: "+err);}
}



module.exports.addReserva = addReserva;

async function comprobarDescuento(reserva){
    try{
        let conn = await mariadb.getConn();
        const evento = await conn.query("SELECT * FROM evento WHERE id = ?", [reserva.eventoID]);
        if(evento.tipoDescuento){
            const porciento = await conn.query("SELECT porciento FROM descuentos WHERE id = ?", [evento.tipoDescuento]);
            return porciento;
        }
        else return null;
    }catch(err){
        console.log("No se pudo acceder a la BD: "+err);
    }
    
}

module.exports.comprobarDescuento = comprobarDescuento;
